# Build configuration

%ifarch %{arm} aarch64 %{ix86}
%define build_docs 0
%else
%define build_docs 0
%endif

%bcond_without examples

# Versioning

%define qtmajor 6
%define qtminor 7
%define qtsubminor 1
%define qtversion  %{qtmajor}.%{qtminor}.%{qtsubminor}

%define rel 2

%define snapshot 0

%if 0%{?snapshot}
%define pre rc
%endif

%define qttarballdir qtwebsockets-everywhere-src-%{qtversion}%{?pre:-%{pre}}

# Library names

%define libqtwebsockets   %mklibname qt%{qtmajor}websockets %{qtmajor}
%define libqtwebsockets_d %mklibname qt%{qtmajor}websockets -d

Name:           qtwebsockets6
Version:        %{qtversion}
Release:        %mkrel %{rel}
Summary:        Qt%{qtmajor} WebSockets component
Group:          Development/KDE and Qt
License:        LGPLv2 with exceptions or GPLv3 with exceptions and GFDL
URL:            https://www.qt.io/
Source0:        https://download.qt.io/official_releases/qt/%{qtmajor}.%{qtminor}/%{version}/submodules/%{qttarballdir}.tar.xz
#Branch Patchs

#Trunk Patchs

#Patch from Mageia
Patch0:         qtwebsockets-fix-requires.patch

BuildRequires:  qtbase6-devel >= %{version}
BuildRequires:  cmake(Qt6Qml) >= %{version}
BuildRequires:  cmake(Qt6Quick) >= %{version}
BuildRequires:  cmake(Qt6QuickTest) >= %{version}
BuildRequires:  cmake(Qt6QmlIntegration) >= %{version}
BuildRequires:  ninja
BuildRequires:  qttools6

Provides:       qt%{qtmajor}-qtwebsockets = %{version}-%{release}

%description
Qt%{qtmajor} WebSockets is a pure Qt implementation of WebSockets - both client and
server.
It is implemented as a Qt add-on module, that can easily be embedded into
existing Qt projects. It has no other dependencies than Qt.

%files
%{_qt6_qmldir}/QtWebSockets/

#------------------------------------------------------------------------------

%if %{build_docs}
%package        doc
Summary:        QtWebSockets%{qtmajor} APIs and tools docs
Group:          Documentation
BuildArch:      noarch
BuildRequires:  qttools6
# This one is required to build QCH-format documentation
# for APIs and tools in this package set
BuildRequires:  qttools6-assistant
Recommends:     qttools6-assistant

%description doc
Documentation for APIs and tools in QtWebSockets%{qtmajor} package for
use with Qt Assistant.

%files doc
%{_qt6_docdir}/qtwebsockets.qch
%{_qt6_docdir}/qtwebsockets/
%endif

#------------------------------------------------------------------------------

%package -n     %{libqtwebsockets}
Summary:        Qt%{qtmajor} WebSockets Library
Group:          System/Libraries
Requires:       %{name} >= %{version}

%description -n %{libqtwebsockets}
Qt%{qtmajor} WebSockets Component Library.

QtWebSockets is a pure Qt implementation of WebSockets - both client and
server.

%files -n %{libqtwebsockets}
%{_qt6_libdir}/libQt6WebSockets.so.%{qtmajor}{,.*}

#------------------------------------------------------------------------------

%package -n     %{libqtwebsockets_d}
Summary:        Devel files needed to build apps based on QtWebSockets
Group:          Development/KDE and Qt
Requires:       %{name} = %{version}
Requires:       %{libqtwebsockets} = %version
Requires:       qtbase6-common-devel = %{version}
Provides:       libqtwebsockets6-devel = %version
Provides:       qtwebsockets6-devel = %version

Provides:       libqtwebsockets6-private-devel = %version
Provides:       libqt6websockets-private-devel = %version
Provides:       qtwebsockets6-private-devel = %version
Provides:       qt6websockets-private-devel = %version
Requires:       qt6core-private-devel = %version

%description -n %{libqtwebsockets_d}
Devel files needed to build apps based on Qt WebSockets.

%files -n %{libqtwebsockets_d}
%{_qt6_includedir}/QtWebSockets/
%{_qt6_libdir}/libQt6WebSockets.so
%{_qt6_libdir}/libQt6WebSockets.prl
%{_qt6_libdir}/cmake/Qt6WebSockets/
%{_qt6_libdir}/pkgconfig/Qt6WebSockets.pc
%{_qt6_archdatadir}/mkspecs/modules/*.pri
%{_qt6_libdir}/qt6/metatypes/qt6websockets_relwithdebinfo_metatypes.json
%{_qt6_libdir}/qt6/modules/WebSockets.json
%if %{with examples}
%{_qt6_examplesdir}/websockets/
%endif
#
%{_qt6_libdir}/cmake/Qt6Qml/*
%{_qt6_libdir}/cmake/Qt6BuildInternals/*

#------------------------------------------------------------------------------

%prep
%setup -q -n qtwebsockets-everywhere-src-%{qtversion}
%autopatch -p1

%build
%cmake_qt6 %{!?with_examples:-DQT_BUILD_EXAMPLES:BOOL=OFF}

%cmake_build

%if %{build_docs}
%__make docs
%endif

%install
%cmake_install

%if %{build_docs}
%make_install install_docs INSTALL_ROOT=%{buildroot}
%endif

# .la and .a files, die, die, die.
find %{buildroot} -name '*.la' -delete
find %{buildroot} -name '*.a' -delete


%changelog
* Tue Jun 11 2024 daviddavid <daviddavid> 6.7.1-2.mga10
+ Revision: 2072563
- rebuild for 'Qt_$MAJOR_PRIVATE_API' settings

* Thu May 23 2024 daviddavid <daviddavid> 6.7.1-1.mga10
+ Revision: 2066232
- New version 6.7.1

* Thu Feb 15 2024 daviddavid <daviddavid> 6.6.2-1.mga10
+ Revision: 2041676
- New version 6.6.2

* Thu Oct 19 2023 daviddavid <daviddavid> 6.6.0-1.mga10
+ Revision: 1999066
- New version 6.6.0

* Mon Sep 11 2023 neoclust <neoclust> 6.5.2-1.mga10
+ Revision: 1986121
- New version 6.5.2

* Thu Dec 15 2022 neoclust <neoclust> 6.4.1-1.mga9
+ Revision: 1923067
- New version 6.4.1
+ wally <wally>
- drop unneeded obsoletes

* Fri Sep 30 2022 neoclust <neoclust> 6.4.0-1.mga9
+ Revision: 1893456
- New version 6.4.0

* Tue Aug 30 2022 neoclust <neoclust> 6.3.1-1.mga9
+ Revision: 1882347
- New version 6.3.1

* Sat Jul 30 2022 wally <wally> 6.3.0-2.mga9
+ Revision: 1873222
- rebuild for core/release

* Thu Jun 02 2022 neoclust <neoclust> 6.3.0-1.mga9
+ Revision: 1861085
- New version 6.3.0

* Sun Apr 10 2022 tmb <tmb> 6.2.3-2.mga9
+ Revision: 1848548
- Mageia 9 Mass Rebuild

* Wed Mar 16 2022 neoclust <neoclust> 6.2.3-1.mga9
+ Revision: 1794417
- New version 6.2.3
+ papoteur <papoteur>
- imported package qtwebsockets6

